#include "os.h"

int main()
{
    k_clear_screen();
    gdt_install(); idt_install(); isrs_install(); irq_install(); ODA_install;
    timer_install(); keyboard_install();
    sti();

    set_cursor(0,0);
    printformat("   ************************************************\n");
	printformat("   *           Welcome to PrettyOS                *\n");
	printformat("   *           Demo of the Key Queue              *\n");
	printformat("   ************************************************\n");

    // demo of the Key Queue (KQ)
    settextcolor(2,0);
    UCHAR c=0;
	while(TRUE)
	{
	  if( k_checkKQ_and_print_char() )
	  {
	    ++c;
	    if(c>5)
	    {
	      c=0;
	      settextcolor(4,0);
	      printformat("\nT: %x H: %x WRITE: %i Read: %i ",
	      pODA->pTailKQ, pODA->pHeadKQ, pODA->KQ_count_write, pODA->KQ_count_read);
          printformat("*T: %c %i *H: %c %i\n",
          *(pODA->pTailKQ),*(pODA->pTailKQ),*(pODA->pHeadKQ),*(pODA->pHeadKQ));
          settextcolor(2,0);
	    }
	  }
	}
	return 0;
};
